HC = require ("hardoncollider")
cron = require ("cron")

speed = 150
char_x = 216 -- new variables for the sprite position
char_y = 216
attackdraw = false
attackdir = 4
attacktime = 0
enemy1exist = true
enemy1draw = true
enemy2exist = true
enemy2draw = true
enemy3exist  = true
enemy3draw = true

function on_collide( dt, shape_a, shape_b)
	local other

	if shape_a == attack then
	    other = shape_b
	    -- killPart(other)
	    if shape_b == enemy1 then
	        Collider:remove(enemy1)
	        enemy1draw = false
	        enemy1exist = false
	   	end
	   	if shape_b == enemy2 then
	   	    Collider:remove(enemy2)
	   	    enemy2draw = false
	   	    enemy2exist = false
	   	end
	   	if shape_b == enemy3 then
	   	    Collider:remove(enemy3)
	   	    enemy3draw = false
	   	    enemy3exist = false
	   	end
	    print('Ataque colidiu com "shape_b"')
	elseif shape_b == attack then
	    other = shape_a
	    -- killPart(other)
	    if shape_a == enemy1 then
	        Collider:remove(enemy1)
	        enemy1draw = false
	        enemy1exist = false
	   	end
	   	if shape_a == enemy2 then
	   	    Collider:remove(enemy2)
	   	    enemy2draw = false
	   	    enemy2exist = false
	   	end
	   	if shape_a == enemy3 then
	   	    Collider:remove(enemy3)
	   	    enemy3draw = false
	   	    enemy3exist = false
	   	end
	    print('Attack collided with "shape_a"')
	end

end

function playerCollision( shape )
	print("collided!")
end

function killAttack()
	if attackdraw then
		Collider:remove(attack)
    	attackdraw = false
	end
end

function testCron()
	print("Five seconds have passed!")
end

local tester = cron.after(5, testCron)

function love.load(  )
	Collider = HC(100, on_collide)

	char = Collider:addRectangle(200, 200, 32, 32)
	char.type = "player"
	enemy1 = Collider:addRectangle(282, 232, 32, 32)
	enemy1.type = "enemy"
	enemy2 = Collider:addRectangle(282, 200, 32, 32)
	enemy2.type = "enemy"
	enemy3 = Collider:addRectangle(250, 232, 32, 32)
	enemy3.type = "enemy"
	enemies = {enemy1,enemy2,enemy3}

	alsina = love.graphics.newFont("fonts/Alsina_Ultrajada.TTF", 15)
	love.graphics.setFont(alsina)
	char_sprite = love.graphics.newImage("character.png")

	dx = 0
	dy = 0

	if not on_collide then
		dx, dy = char:center()
	end
end

function love.update( dt ) -- Changed all the elseifs into seperate if statements to allow for diagonal movement
	function movement(x,y) --collision is now done from this functiom
		x,y = char_x + x, char_y + y --adds the movement to the current char position
		char:moveTo(x,y) --moves the character to the correct space
		for i,v in ipairs(enemies) do --this loop goes through all the enemies
			if enemy1exist or enemy2exist or enemy3exist then
				if char:collidesWith(v) then --this checks if the object is colliding
					colliding = true
					char:moveTo(char_x,char_y) --if it is, then it moves back to the position before it moved
				end
			end
		end
		if colliding ~= true then
			char_x,char_y = x,y --if it isn't then the character sprite moves there as well
		end
		colliding = false --this has to be reset for the next time you move
	end

	if love.keyboard.isDown("up") then
		movement(0, -1 * speed * dt)
		attackdir = 1
	end
	if love.keyboard.isDown("down") then
		movement(0, 1 * speed * dt)
		attackdir = 2
	end
	if love.keyboard.isDown("left") then
		movement(-1 * speed * dt, 0)
		attackdir = 3
	end
	if love.keyboard.isDown("right") then
		movement(1 * speed * dt, 0)
		attackdir = 4
	end

	if tester then
	    tester:update(dt)
	end
	if attackdraw then
    	if killTester then
		    killTester:update(dt)
		end
	end

	function respawn()
		if not enemy1exist or not enemy2exist or not enemy3exist then
			enemy1 = Collider:addRectangle(282, 232, 32, 32)
			enemy1.type = "enemy"
			enemy1exist = true
			enemy1draw = true
			enemy2 = Collider:addRectangle(282, 200, 32, 32)
			enemy2.type = "enemy"
			enemy2exist = true
			enemy2draw = true
			enemy3 = Collider:addRectangle(250, 232, 32, 32)
			enemy3.type = "enemy"
			enemy3exist = true
			enemy3draw = true
		end
	end

	function newAttack()
		if not attackdraw then
			if attackdir == 1 then
			    attack = Collider:addRectangle(char_x - 8, char_y - 48, 16, 16)
			    attack.type = "attack"
			    attackdraw = true
			    killTester = cron.after(0.2, killAttack)
			end
			if attackdir == 2 then
			    attack = Collider:addRectangle(char_x - 8, char_y + 32, 16, 16)
			    attack.type = "attack"
			    attackdraw = true
			    killTester = cron.after(0.2, killAttack)
			end
			if attackdir == 3 then
			    attack = Collider:addRectangle(char_x - 48, char_y - 8, 16, 16)
			    attack.type = "attack"
			    attackdraw = true
			    killTester = cron.after(0.2, killAttack)
			end
			if attackdir == 4 then
			    attack = Collider:addRectangle(char_x + 32, char_y - 8, 16, 16)
			    attack.type = "attack"
				attackdraw = true
				killTester = cron.after(0.2, killAttack)
			end
		end
	end

	Collider:update(dt)
end

function killPart(shape)
	Collider:remove(shape)
end


function love.keypressed(key)
	if key == " " then
		newAttack()
	end
	if key == "r" then
	    respawn()
	end
end

function love.draw(  )
	love.graphics.setColor(100, 100, 100, 255)
	love.graphics.draw(char_sprite, char_x, char_y, 0, 1, 1, 32/2, 32/2)
	love.graphics.setColor(100, 100, 200, 255)
	if enemy1exist or enemy2exist or enemy3exist then
		enemy1aura = love.graphics.rectangle("fill", 282, 232, 32, 32)
		enemy2aura = love.graphics.rectangle("fill", 282, 200, 32, 32)
		enemy3aura = love.graphics.rectangle("fill", 250, 232, 32, 32)
	end
	love.graphics.setColor(255, 255, 255, 255)
	if enemy1draw then
		enemy1:draw("fill")
	end
	if enemy2draw then
		enemy2:draw("fill")
	end
	if enemy3draw then
		enemy3:draw("fill")
	end
	if attackdraw then
		love.graphics.setColor(100, 250, 100, 255)
		attack:draw("fill")
	end

	love.graphics.setColor(255, 255, 255, 255)

	love.graphics.print("Movement Demo ver.0.3", 1, 1)
	love.graphics.print("Hardon Collider", 710, 1)
	love.graphics.print("Space to attack, arrow keys to move. R to respawn the enemies (beware the bugs!)", 1, 580)
	love.graphics.print("X: " .. char_x .. ", Y: " .. char_y, 150, 1)
end